#include "main.h"
#include <iostream>
#include <SDL.h>
#include <SDL_image.h>
#include <SDL_ttf.h>
#include <cmath>
#include <stdio.h>      /* printf, scanf, puts, NULL */
#include <stdlib.h>     /* srand, rand */
#include <time.h>       /* time */


#define PI 3.14159265
const float FDR_BORDER = 3.6;
const float SPEED_FACTOR = 3000.0;
const float SLOWDOWN = 0.96;
const float SPEED_BORDER = 80;
const float ACCEL = 1.0;
const int BG_BOUND=40;
const int RANDOM_VARIATION = 20;
const int BG_SPEED = 50;
const float MAX_RUNS = 100;
const int SLOW_BG = 1;
const int SLOW_BG_BOUND = 30;
const int COLOUR_SPEED = 4;
const int RING_SPEED_ACCEL_MIN = 3;
const int RING_SPEED_ACCEL_MAX = 5;
const float RING_SPEED=50;
const int RING_DOTS = 360;
const float RING_RADIUS = 160;
const float RING_MULTI = 0.5;
const float COUNTER_CHANGE = 0.2;
const float RING_LENGTH = 25;


struct Coord
{
  float x, y;
};
struct Dot
{
  Coord current, dest, vector;
};

class V_Dot
{
public:
  Coord current;

  float angle;
  float length;
  float accel;
  Coord get_vector()
  {
    float x = sin(angle) * length;
    float y = cos(angle) * length;
    return {x, y};

  }

  void set_position(float angle, float length)
  {
    current.x = sin(angle) * length;
    current.y = cos(angle) * length;
  }

  Coord get_position()
  {
    return current;
  }



  float get_vector_length()
  {
    return length;
  }


  float get_vector_angle()
  {
      return angle;
  }

};  

Uint32 get_pixel32( SDL_Surface *surface, int x, int y )
{
    //Convert the pixels to 32 bit
    Uint32 *pixels = (Uint32 *)surface->pixels;
    
    //Get the requested pixel
    return pixels[ ( y * surface->w ) + x ];
}


void put_pixel32( SDL_Surface *surface, int x, int y, Uint32 pixel ) 
{ //Convert the pixels to 32 bit 
  Uint32 *pixels = (Uint32 *)surface->pixels; 
  //Set the pixel 
  pixels[ ( y * surface->w ) + x ] = pixel; 
}

Uint32 getpixel(SDL_Surface *surface, int x, int y)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to retrieve */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
    case 1:
        return *p;
        break;

    case 2:
        return *(Uint16 *)p;
        break;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
            return p[0] << 16 | p[1] << 8 | p[2];
        else
            return p[0] | p[1] << 8 | p[2] << 16;
        break;

    case 4:
        return *(Uint32 *)p;
        break;

    default:
        return 0;       /* shouldn't happen, but avoids warnings */
    }
}

void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to set */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
    case 1:
        *p = pixel;
        break;

    case 2:
        *(Uint16 *)p = pixel;
        break;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN) {
            p[0] = (pixel >> 16) & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = pixel & 0xff;
        } else {
            p[0] = pixel & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = (pixel >> 16) & 0xff;
        }
        break;

    case 4:
        *(Uint32 *)p = pixel;
        break;
    }
}



template <typename T> int sgn(T val) {
    return (T(0) < val) - (val < T(0));
}

template <typename T> float sgn_f(T val)
{
  return sgn(val);
}

enum States
{
  FDR,
  TRANSITION,
  THUNDER_FUCK_YEAH
};



















int main()
{

  srand( time(NULL) );
  
  SDL_Init(SDL_INIT_EVERYTHING);
  TTF_Init();
    TTF_Font *font = TTF_OpenFont("DejaVuSansMono.ttf", 14);
  SDL_Surface * fdr = IMG_Load("fdr.png");

    Uint32 rmask, gmask, bmask, amask;

    /* SDL interprets each pixel as a 32-bit number, so our masks must depend
       on the endianness (byte order) of the machine */
#if SDL_BYTEORDER == SDL_BIG_ENDIAN
    rmask = 0xff000000;
    gmask = 0x00ff0000;
    bmask = 0x0000ff00;
    amask = 0x000000ff;
#else
    rmask = 0x000000ff;
    gmask = 0x0000ff00;
    bmask = 0x00ff0000;
    amask = 0xff000000;
#endif

  SDL_Surface * white_alpha = SDL_CreateRGBSurface(0, 640, 480, 32, rmask, gmask, bmask, amask);

  SDL_Surface * screen = SDL_SetVideoMode(640, 480, 32, SDL_DOUBLEBUF | 0);
  std::cout<<fdr<<std::endl;
  int count_pixels = 0;
  for(int x = 0; x<fdr->w; x++)
  {
    for(int y = 0; y<fdr->h; y++)
    {
      Uint32 colour = getpixel(fdr, x, y);
      if(colour == 0)
        count_pixels++;
    }
  }

  Dot * dots = new Dot[count_pixels];


  count_pixels=0;
  for(int x = 0; x<fdr->w; x++)
  {
    for(int y = 0; y<fdr->h; y++)
    {
      Uint32 colour = getpixel(fdr, x, y);
      if(colour == 0)
      {
        dots[count_pixels].current = {float(rand()%640), float(rand()%480) };
        dots[count_pixels].dest = {(float) x+320-133 , (float)y+240-100};
        dots[count_pixels].vector = {float(    (  rand()%RANDOM_VARIATION)-(RANDOM_VARIATION/2)  )   , float(       (rand() % RANDOM_VARIATION) - (RANDOM_VARIATION/2)         )};
        count_pixels++;
      }
    }
  }

  int * upper = new int[5];
  int * lower = new int[5];

  int * up_var = new int[5];
  int * low_var = new int[5];

  std::fill_n(up_var, 5, -40);
  std::fill_n(low_var, 5, -40);

  Uint32 text_r, text_b, text_g, dest_r, dest_g, dest_b;


  for(int i = 0; i<5; i++)
  {
    upper[i] = rand()%BG_BOUND;
    lower[i] = rand()%BG_BOUND;
  }

  SDL_Event e;
  bool end = false;
  States state = FDR;

  float bg_pos = -BG_BOUND;

  float runs = 0;

    V_Dot * dot_ring;
    float ring_counter = 0;
  while(!end)
  {

    
    SDL_FillRect(screen, NULL, 0x000000);
    float dist_x = 0;
    float dist_y = 0;



    if(FDR == state)
    {
      for(int i= 0; i<count_pixels; i++)
      {
        dots[i].current.x = dots[i].current.x+dots[i].vector.x;
        dots[i].current.y = dots[i].current.y+dots[i].vector.y;
        dots[i].vector.x += ( -sgn_f(dots[i].current.x - dots[i].dest.x)*ACCEL );
        dots[i].vector.y += ( -sgn_f(dots[i].current.y - dots[i].dest.y)*ACCEL );
        dots[i].vector.x *= SLOWDOWN;
        dots[i].vector.y *= SLOWDOWN;

        dist_x += abs(dots[i].current.x-dots[i].dest.x);
        dist_y += abs(dots[i].current.y-dots[i].dest.y);


        if(dots[i].current.x > 0 && dots[i].current.x < 640 && dots[i].current.y > 0 && dots[i].current.y < 480)
          putpixel(screen, dots[i].current.x, dots[i].current.y, 0x0011FF11);
      }
      float global_dist = (dist_x/count_pixels) + (dist_y/count_pixels);
      std::cout<<global_dist<<std::endl;
      if( global_dist < FDR_BORDER)
      {
        state = TRANSITION;
      }
    }
    else if(TRANSITION == state)
    {



      for(int i = 0; i<5; i++)
      {
        SDL_Rect rect;
        rect.x = i*128;
        rect.y = 0;
        rect.w = 64;
        rect.h= upper[i]+bg_pos;
        if(rect.h>0 && bg_pos>0)
          SDL_FillRect(screen, &rect, 0x444444);


        rect.x+=64;
        rect.h=bg_pos-lower[i];
        if(rect.h>0 && bg_pos>0)
        SDL_FillRect(screen, &rect, 0x444444);



        rect.x = i*128;
        rect.y = 480-bg_pos+upper[i];
        rect.w = 64;
        rect.h= (upper[i]-bg_pos);
        if(rect.h>0 && bg_pos>0)
          SDL_FillRect(screen, &rect, 0x333333);


        rect.x+=64;
        rect.y = 480-bg_pos-lower[i];
        rect.h=-(bg_pos+lower[i]);
        if(rect.h>0 && bg_pos>0)
        SDL_FillRect(screen, &rect, 0x333333);
      }

      bg_pos+=BG_SPEED;

      if(bg_pos>240)
      {
        bg_pos = 240;
        state = THUNDER_FUCK_YEAH;

        dot_ring = new V_Dot[RING_DOTS];

        for(int i = 0; i<RING_DOTS; i++)
        {
          float angle = float(i)*(PI/180.0);
          dot_ring[i].set_position(angle, RING_RADIUS);
          dot_ring[i].angle = angle;
          dot_ring[i].accel = RING_SPEED_ACCEL_MIN+(rand()%(RING_SPEED_ACCEL_MAX - RING_SPEED_ACCEL_MIN));
          dot_ring[i].length = 1;
        }
      }

      for(int i= 0; i<count_pixels; i++)
      {
        dots[i].current.x = dots[i].current.x+dots[i].vector.x;
        dots[i].current.y = dots[i].current.y+dots[i].vector.y;
        dots[i].vector.x += ( -sgn_f(dots[i].current.x - dots[i].dest.x)*ACCEL );
        dots[i].vector.y += ( -sgn_f(dots[i].current.y - dots[i].dest.y)*ACCEL );
        dots[i].vector.x *= SLOWDOWN/2.0;
        dots[i].vector.y *= SLOWDOWN/2.0;

        dist_x += abs(dots[i].current.x-dots[i].dest.x);
        dist_y += abs(dots[i].current.y-dots[i].dest.y);


        if(dots[i].current.x > 0 && dots[i].current.x < 640 && dots[i].current.y > 0 && dots[i].current.y < 480)
          putpixel(screen, dots[i].current.x, dots[i].current.y, 0x0011FF11);
      }

      dest_r = rand()%256;
      dest_g = rand()%256;
      dest_b = rand()%256;

      text_r = dest_r;
      text_g = dest_g;
      text_b = dest_b;

    }
    else if(THUNDER_FUCK_YEAH == state)
    {

      if(abs(text_r - dest_r)<= COLOUR_SPEED)
      {
        dest_r = rand()%256;
      }
      if(abs(text_g - dest_g)<= COLOUR_SPEED)
      {
        dest_g = rand()%256;
      }
      if(abs(text_b - dest_b) <= COLOUR_SPEED)
      {
        dest_b = rand()%256;
      }

      if(text_r < dest_r)
      {
        text_r +=COLOUR_SPEED;
      }
      else
      {
        text_r -=COLOUR_SPEED;
      }
      if(text_g < dest_g)
      {
        text_g += COLOUR_SPEED;
      }
      else
      {
        text_g -= COLOUR_SPEED;
      }
      if(text_b < dest_b)
      {
        text_b += COLOUR_SPEED;
      }
      else
      {
        text_b -= COLOUR_SPEED;
      }


      SDL_Colour col = {(Uint8) text_r,(Uint8)  text_g,(Uint8)  text_b, 255};
      SDL_Surface * text = TTF_RenderText_Solid(font, "+++ CRACKTRO BY FEIDER +++ BEST CRACKTRO EVER +++ POWERED BY C/C++ & SDL1.2 +++", col);

      SDL_Surface * text2 = TTF_RenderText_Solid(font, "++++++++++ :#:#:#:#:#:#:#:#: ++++++++++", col);

      for(int i = 0; i<5; i++)
      {



        if(abs(up_var[i]-upper[i]) <= SLOW_BG)
        {
          int temp = rand()%BG_BOUND;

          if(up_var[i]>0)
          {
            up_var[i] = -temp;
          }
          else
          {
            up_var[i] = temp;
          }
        }

        if(upper[i] > low_var[i])
          upper[i]-=SLOW_BG;
        else
          upper[i]+=SLOW_BG;

        if(abs(lower[i] - low_var[i]) <= SLOW_BG)
        {
          int temp = rand()%BG_BOUND;

          if(low_var[i]>0)
          {
            low_var[i] = -temp;
          }
          else
          {
            low_var[i] = temp;
          }



        }

        if(lower[i] > low_var[i])
          lower[i]-=SLOW_BG;
        else
          lower[i]+=SLOW_BG;



        SDL_Rect rect;
        rect.x = i*128;
        rect.y = 0;
        rect.w = 64;
        rect.h= upper[i]+bg_pos;


        rect.x = i*128;
        rect.y = 480-(bg_pos-upper[i]);
        rect.w = 64;
        rect.h= 240-upper[i];
        if(rect.h>0 && bg_pos>0)
          SDL_FillRect(screen, &rect, 0x333333);


        rect.x+=64;
        rect.y = 480-(bg_pos-lower[i]);
        rect.h=240-lower[i];
        if(rect.h>0 && bg_pos>0)
        SDL_FillRect(screen, &rect, 0x333333);



        rect.x = i*128;
        rect.y = 0;
        rect.w = 64;
        rect.h= upper[i]+bg_pos;
        if(rect.h>0 && bg_pos>0)
          SDL_FillRect(screen, &rect, 0x444444);


        rect.x+=64;
        rect.h=bg_pos+lower[i];
        if(rect.h>0 && bg_pos>0)

        SDL_FillRect(screen, &rect, 0x444444);


        rect.x = i*128;
        rect.y = upper[i]+bg_pos;
        rect.w = 64;
        rect.h = 2;        
        SDL_FillRect(screen, &rect, SDL_MapRGB(screen->format, col.r, col.g, col.b));


        rect.x +=64;
        rect.y = bg_pos+lower[i];
        rect.w = 64;
        rect.h = 2;
        SDL_FillRect(screen, &rect, SDL_MapRGB(screen->format, col.r, col.g, col.b));
      }


      ring_counter += COUNTER_CHANGE;
      if(ring_counter >= 360)
        ring_counter = 0;

      for(int i = 0; i<RING_DOTS; i++)
      {
        float x = dot_ring[i].current.x+320;
        float y = dot_ring[i].current.y+240;
        dot_ring[i].length = (sin(      (((ring_counter*(PI/180.0))  +dot_ring[i].angle) * 7)  )+(sin((( (-ring_counter*(PI/180.0))  +dot_ring[i].angle) * 19))/3.0) ) * RING_LENGTH;


        float add_x = dot_ring[i].get_vector().x;
        float add_y = dot_ring[i].get_vector().y;

        x = x +add_x;
        y = y + add_y;


        if(x >1 && x<639 && y>1 && y<479)
        {
          putpixel(screen, x, y, SDL_MapRGB(screen->format, 255-col.r, 255-col.g, 255-col.b));
          putpixel(screen, x+1, y+1, SDL_MapRGB(screen->format, 255-col.r, 255-col.g, 255-col.b));
          putpixel(screen, x+1, y-1, SDL_MapRGB(screen->format, 255-col.r, 255-col.g, 255-col.b));
          putpixel(screen, x-1, y+1, SDL_MapRGB(screen->format, 255-col.r, 255-col.g, 255-col.b));
          putpixel(screen, x-1, y-1, SDL_MapRGB(screen->format, 255-col.r, 255-col.g, 255-col.b));
        }

        x = 639-x;
        y = 479-y;
        if(x >1 && x<639 && y>1 && y<479)
        {
          putpixel(screen, x, y, SDL_MapRGB(screen->format, 255-col.r, 255-col.g, 255-col.b));
          putpixel(screen, x+1, y+1, SDL_MapRGB(screen->format, 255-col.r, 255-col.g, 255-col.b));
          putpixel(screen, x+1, y-1, SDL_MapRGB(screen->format, 255-col.r, 255-col.g, 255-col.b));
          putpixel(screen, x-1, y+1, SDL_MapRGB(screen->format, 255-col.r, 255-col.g, 255-col.b));
          putpixel(screen, x-1, y-1, SDL_MapRGB(screen->format, 255-col.r, 255-col.g, 255-col.b));
        }
      }

      //SDL_Rect rekt = {296, 208, 10, 10};
      //SDL_FillRect(screen, &rekt, SDL_MapRGB(screen->format, col.r, col.g, col.b));
      for(int i= 0; i<count_pixels; i++)
      {
        dots[i].current.x = dots[i].current.x+dots[i].vector.x;
        dots[i].current.y = dots[i].current.y+dots[i].vector.y;
        dots[i].vector.x += ( -sgn_f(dots[i].current.x - dots[i].dest.x)*ACCEL );
        dots[i].vector.y += ( -sgn_f(dots[i].current.y - dots[i].dest.y)*ACCEL );
        dots[i].vector.x *= SLOWDOWN/3.0;
        dots[i].vector.y *= SLOWDOWN/3.0;

        dist_x += abs(dots[i].current.x-dots[i].dest.x);
        dist_y += abs(dots[i].current.y-dots[i].dest.y);


        if(dots[i].current.x > 0 && dots[i].current.x < 640 && dots[i].current.y > 0 && dots[i].current.y < 480)
          putpixel(screen, dots[i].current.x, dots[i].current.y, 0x0011FF11);
      }


      SDL_Rect r = {3, 400, 0, 0};
      SDL_BlitSurface(text, 0, screen, &r);
      r = {170, 66, 0, 0};
      SDL_BlitSurface(text2, 0, screen, &r);

      float alpha = (255*(1.0 - (runs/MAX_RUNS)));
      if(alpha>0)
      {
        SDL_FillRect(white_alpha, 0, SDL_MapRGBA(white_alpha->format, 255, 255, 255, alpha));
        SDL_BlitSurface(white_alpha, 0, screen, 0);
        runs+=1;
      }

      SDL_FreeSurface(text);
      SDL_FreeSurface(text2);


    }


    SDL_Delay(30);

    SDL_Flip(screen);

    while(SDL_PollEvent(&e))
    {
      if(e.type == SDL_KEYDOWN || e.type == SDL_QUIT)
      {
        end = true;
      }
    }
  }


  delete [] dots;
  delete [] dot_ring;
  SDL_FreeSurface(fdr);
  SDL_Quit();
  return 0;
}
